unit WOwnrScrllBar;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
TOSBKind = (osbVertical,osbHorizontil);
TOSBDrawStyle = (osbStandard,osbOwnerDraw);

TOSBEvent = procedure(Sender: TObject;Rect: TRect; State: Boolean) of Object;
  TWOwnrScrllBar = class(TCustomControl)
  private
    { Private declarations }
  protected
    { Protected declarations }
  bCtrl3d,mdown:boolean;
  fButHeight,fTrackHeight:integer;
  fMin,fMax,fPosition:longint;
  tKind:TOSBKind;
  tDrawstyle:TOSBDrawStyle;
  iTracky:integer;
  iLasRect:Trect; //used by poisition property
  fSmallChange:Integer;
  fAutoSizeTrack:Boolean;
  fMinTrackSize:Integer;
  fLargeChange:Integer;

  fOnChange:TNotifyEvent;
  FTopDraw : TOSBEvent;
  FTrackDraw : TOSBEvent;
  FBottomDraw : TOSBEvent;

  procedure FireTopDraw(Rect: TRect; State: Boolean);
  procedure FireTrackDraw(Rect: TRect; State: Boolean);
  procedure fireBottomDraw(Rect: TRect; State: Boolean);
  Procedure DoChange;virtual;


  procedure setPosition(pos:integer);
  procedure SetAutoSizeTrack(yesno:boolean);
  function TrackArea:integer;
  Procedure SetSizeOfTrack;
  public
    { Public declarations }
    property Canvas;
    function TrackRect:Trect;
    constructor Create(AOwner: TComponent); override;
   destructor  Destroy; override;
  published
    { Published declarations }
    Property DrawStyle:TOSBDrawStyle read tDrawstyle write tDrawstyle;
    Property Align;
    Property Enabled;
    Property Visible;
    Property Hint;
    Property ShowHint;
    Property Cursor;


    Property Ctrl3D:boolean read bCtrl3d write bCtrl3d;
    Property ButtonHeight:integer read fButheight write fButheight;
    Property Max:longint read fMax write fMax;
    Property Min:Longint read fMin write fMin;
    Property TrackHeight:integer read fTrackHeight write fTrackHeight;
    Property Position:Longint read fPosition write setPosition;
    Property SmallChange:Integer read fSmallChange write fSmallChange;
    Property AutoSizeTrack:Boolean read fAutoSizeTrack write SetAutoSizeTrack;
    property MinTrackSize:Integer read fMinTrackSize write fMinTrackSize;
    Property LargeChange:integer read fLargeChange write fLargeChange;
    Property OnDragOver;
    Property OnEndDrag;
    Property OnDragDrop;

    Property OnChange:TNotifyEvent read fOnChange write fOnChange;
    Property OnTopDraw:TOSBEvent read fTopDraw write fTopDraw;
    Property OnTrackDraw:TOSBEvent read fTrackDraw write fTrackDraw;
    Property OnBottomDraw:TOSBEvent read fBottomDraw write fBottomDraw;

    Procedure paint;override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
   Procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
   procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;


  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('WAISS', [TWOwnrScrllBar]);
end;

//------------------------------------------------------------------------------
constructor TWOwnrScrllBar.Create(AOwner: TComponent);
begin

inherited Create(AOwner);
height := 100;
width := 20;
fButHeight:=18;
fMin := 1;
fMax := 100;
fPosition := 50;
TrackHeight := 18;
bctrl3d := True;
//benabled := true;
fSmallChange := 1;
fMinTrackSize := 6;
fLargeChange := 4;
end;
//------------------------------------------------------------------------------
destructor TWOwnrScrllBar.Destroy;
begin
inherited destroy;
end;
//------------------------------------------------------------------------------
procedure TWownrScrllBar.paint;

var enadd:integer;
begin
if ctrl3d = true then
begin
with canvas do
begin
     pen.color:=clBtnShadow;
     moveto(width,0);
     lineto(0,0);
     lineto(0,Height-1);
     pen.color:=clBtnHighlight;
     lineto(width-1,height-1);
     lineto(width-1,0);
     end;
end;
with canvas do
begin
     //btn paint
        // so that does not redraw the buttons

       if DrawStyle = osbStandard then
       begin
         if not(mdown) then
         begin
         if enabled = false then enadd := dfcs_inactive else enadd := 0;
           drawframecontrol(canvas.handle,rect(1,1,width-1,buttonheight),dfc_scroll,dfcs_scrollup+enadd);
           drawframecontrol(canvas.handle,rect(1,height-buttonheight,width-1,height-1),dfc_scroll,dfcs_scrolldown+enadd);
         end;
       if enabled = true then drawframecontrol(canvas.handle,TrackRect,
        dfc_button,DFCS_BUTTONPUSH	);

       end
       else
       begin
          if not(mdown) then
          begin
          firetopdraw(rect(1,1,width-1,buttonheight),True);
          fireBottomdraw(rect(1,height-buttonheight,width-1,height-1),true);
          end;
          fireTrackDraw(trackRect,true);
       end;
     //rectangle(1,1,width-2,buttonheight)
end;

end;
//------------------------------------------------------------------------------
procedure TWOwnrScrllBar.MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer);
var pt:Tpoint;
var tr:TRect;
begin
tr := TrackRect;

mdown:= true;
if y < ButtonHeight then
begin
     if DrawStyle = osbStandard then
     begin
        drawframecontrol(canvas.handle,rect(1,1,width-1,buttonheight),
        dfc_scroll,dfcs_scrollup+dfcs_flat);
     end
     else
     begin
          firetopdraw(rect(1,1,width-1,buttonheight),false);
     end;
     if position > min then Position := position -SmallChange;
end
else if y > height - buttonHeight then
begin
     if DrawStyle = osbStandard then
     begin
        drawframecontrol(canvas.handle,rect(1,height-buttonheight,width-1,height-1),
        dfc_scroll,dfcs_scrolldown+dfcs_flat);
     end
     else
     begin
         fireBottomdraw(rect(1,height-buttonheight,width-1,height-1),false);
     end;
     if position < max then Position := position +SmallChange;
end
else
begin
     pt.x:=x;
     pt.y:=y;

     if ptinrect(TR,pt) then begin
       itracky:=y-TR.Top;
       mdown := true;
     end
     else            
     begin
       if y < tr.Top then position := position - LargeChange;
       if y > tr.Bottom then position := position + LargeChange;
     end;
                    
end;
end;
//------------------------------------------------------------------------------
procedure TWOwnrScrllBar.MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer);
begin
mdown := false;
paint;
end;

//------------------------------------------------------------------------------
function TWOwnrScrllBar.TrackArea:integer;
begin
result := height - (((ButtonHeight*2)+(TrackHeight ))+1);
end;
//------------------------------------------------------------------------------

Procedure TWOwnrScrllBar.MouseMove(Shift: TShiftState; X, Y: Integer);
var s:Single;
place:integer;
begin
if mdown then begin
place := (y-ButtonHeight) - iTrackY;
s:= (max - min) / TrackArea ;
if (round(place*s) <= max) and (round(place*s) >= Min) then
position := round(place*s);


end;
end;

//------------------------------------------------------------------------------
function TWOwnrScrllBar.TrackRect:Trect;
var s:single;
begin
s:= TrackArea/(max - min);
result.top:=(ButtonHeight+1)+round(s*(position-min));
result.left := 1;
result.Bottom := result.top + trackheight;
result.Right := width - 1;


//result.
end;
//------------------------------------------------------------------------------
procedure TWOwnrScrllBar.setPosition(pos:integer);
begin
if (pos <= max) and (pos >= Min) then
begin
  fPosition := pos;
  if parent <> nil then
  begin
  canvas.brush := parent.brush;
  canvas.fillrect(iLasRect);
  end;
  ilasrect := TrackRect;
  if parent <> nil then
  paint;
  doChange;
end;
end;
//------------------------------------------------------------------------------
Procedure TWOwnrScrllBar.SetSizeOfTrack;
// Procedure to set the size of the TrackBar when the values change
var
v:integer;
begin
if AutoSizeTrack = False then exit;
v :=  TrackArea-(Max - Min) ;
if v < MinTrackSize then v:= MinTrackSize;
TrackHeight := v;
end;
//------------------------------------------------------------------------------
procedure TWOwnrScrllBar.SetAutoSizeTrack(yesno:boolean);
begin
  fAutoSizeTrack := yesno;
  SetSizeOfTrack;
end;
//------------------------------------------------------------------------------
Procedure TWOwnrScrllBar.DoChange;
begin
  if assigned(fOnChange) then
     fonchange(Self);
end;
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
procedure TWOwnrScrllBar.FireTopDraw(Rect: TRect; State: Boolean);
begin
 if assigned(FTopDraw) then FTopDraw(Self,rect,state);
end;
//------------------------------------------------------------------------------
procedure TWOwnrScrllBar.FireTrackDraw(Rect: TRect; State: Boolean);
begin
if assigned(FTrackDraw) then FTrackDraw(Self,rect,state);
end;

//------------------------------------------------------------------------------
procedure TWOwnrScrllBar.fireBottomDraw(Rect: TRect; State: Boolean);
begin
if assigned(FBottomDraw) then FBottomDraw(Self,rect,state);
end;
end.
